﻿/* Cascading Dropdowns v3.6.5
 * -----------------------------
 * Created by Alexander Bautz
 * alexander.bautz@gmail.com
 * http://spjsblog.com
 * Copyright (c) 2009-2017 Alexander Bautz
 * ---------------------------------------------
*/
//# sourceURL=/SPJS/DFFS/plugins/spjs-casc.js
/* SP2013 */
if(typeof _spPageContextInfo !== "undefined"){
	if(_spPageContextInfo.webUIVersion === 15){
		var L_Menu_BaseUrl = _spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl : "";
		var L_Menu_LCID = _spPageContextInfo.currentLanguage.toString();
	}
}

var spjs = spjs || {};
// The file assetpickers.js in SP365 overwrites the $ namespace. 
spjs.$ = spjs.$ || $;

spjs.casc = {
	"version":"3.6.5",
	"vDispName":"3.6.5",
	"versionDate":"January 12, 2017",
	"isDispForm":location.pathname.toLowerCase().indexOf("dispform.aspx") > -1,
	"multi":{},
	"settings":{
		"isSP07":typeof _spPageContextInfo === "undefined" || _spPageContextInfo.webUIVersion === undefined,
		"isSP13":typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 15,
		"multichoiceDelimiter":";\n"		
	},
	"data":{},
	"dataObj":{},
	"cssDone":false,
	"getLocalized":function(){
		var lcid = "";
		if(!spjs.casc.settings.isSP07){
			lcid = _spPageContextInfo.currentLanguage.toString();
		}else{
			lcid = L_Menu_LCID;			
		}
		switch(lcid){
			case "1044":
				spjs.casc.text = {
					"invalidData":"Valget \"{0}\" er ikke gyldig",
					"buttonTextAdd":"Legg til",
					"buttonTextRemove":"Fjern",
					"unselectedOptions":"Tilgjengelige valg",
					"selectedOptions":"Valgte elementer"
				};
			break;
			case "1053":
				spjs.casc.text = {
					"invalidData":"Alternativ \"{0}\" är inte giltigt",
					"buttonTextAdd":"Lägg till",
					"buttonTextRemove":"Ta bort",
					"unselectedOptions":"Tillgängliga alternativ",
					"selectedOptions":"Valda alternativ"
				};
			break;
			default:
				spjs.casc.text = {
					"invalidData":"The selection \"{0}\" is not valid",
					"buttonTextAdd":"Add",
					"buttonTextRemove":"Remove",
					"unselectedOptions":"All options",
					"selectedOptions":"Selected options"
				};
		}
	},
	"css":function(){
		spjs.casc.cssDone = true;
		var cb = [];
		cb.push("<style type='text/css'>");
		cb.push(".spjs_casc_notvalid select{border:1px red dashed;padding:2px;}");
		cb.push("select.spjs_selected.spjs_casc_multi{background-color:#B0D39C;}");
		cb.push("select.spjs_unselected.spjs_casc_multi{background-color:#f5f5f5;}");
		cb.push("select.spjs_casc_multi{width:100%;height:125px;box-sizing:border-box;}");
		cb.push(".spjs_casc_info{font-size:12px;color:#444;cursor:default;}");		
		cb.push(".spjs_casc_hidden{display:none!important;}");		
		cb.push("</style>");
		spjs.$(document).ready(function(){
			spjs.$("body").append(cb.join(""));
		});
	},
	"debugWrite":function(str,style){
		spjs.$("#spjs_casc_debug").append("<div style='"+style+"'>"+str+"</div>");
	},
	"translateStringWithJSON":function(a){	
		if(typeof a === "string" && a.match(/\{(.*?)\}/g) !== null){
			var b;
			spjs.$.each(a.match(/\{(.*?)\}/g),function(i,r){
				try{
					b = spjs.$.parseJSON(r);
					if(b[L_Menu_LCID] !== undefined){
						a = a.replace(r,b[L_Menu_LCID]);
					}else if(b["default"] !== undefined){
						a = a.replace(r,b["default"]);
					}
				}catch(ignore){
					// empty
				}
			});
		}
		return spjs.casc.escapeQuotes(a);
	},
	"init":function(argObj){
		if(argObj.lookupListBaseUrl.toLowerCase() === "{currentsite}"){
			argObj.lookupListBaseUrl = L_Menu_BaseUrl;
		}
		var myMatch, s, err = false;		
		spjs.casc.fields = {};
		spjs.$("td.ms-formbody").each(function(){
			myMatch = spjs.$(this).html().match(/FieldName="(.+)"\s+FieldInternalName="(.+)"\s+FieldType="(.+)"\s+/);	
			if(myMatch!==null){
				spjs.casc.fields[myMatch[2]] = {"type":myMatch[3],"disp":myMatch[1],"field":this.parentNode};
			}		
		});
		// Ensure all fields are available
		spjs.$.each(argObj.thisListFields,function(i,v){
			s = spjs.casc.fields[(v.split(":").length > 1 ? v.split(":")[0] : v)];
			if(s === undefined){
				if(argObj.debug){
					alert("The fieldname \""+v+"\" specified in \"thisListFields\" does not exist.\nYou must use \"FieldInternalName\" to identify the fields.");
				}
				err = true;
				return false;
			}
		});
		if(err){
			return;
		}
		if(spjs.casc.dataObj[argObj.lookupList] === undefined){
			// Not yet retrieved data
			spjs.casc.dataObj[argObj.lookupList] = {"data":null,"fArr":argObj.lookupListFields};
			if(spjs.casc.settings.isSP13){
				spjs.casc.getAllItemsREST({"listName":argObj.lookupList,"listBaseUrl":argObj.lookupListBaseUrl,"viewFields":argObj.lookupListFields},argObj,""); 
			}else{
				spjs.casc.getAllItems({"listName":argObj.lookupList,"listBaseUrl":argObj.lookupListBaseUrl,"viewFields":argObj.lookupListFields},argObj); 
			}
		}else{
			// Waiting for data
			var fMatch = true;
			spjs.$.each(argObj.lookupListFields,function(i,fin){
				if(spjs.$.inArray(fin,spjs.casc.dataObj[argObj.lookupList].fArr) < 0){
					fMatch = false;
				}
			});
			if(!fMatch){
				alert("[SPJS Cascading dropdowns :: ERROR]\n\nYou have two of more instancens of cascading dropdowns reading from the same datasource. Because the query to get all items only runs once for each datasource, you must ensure you include all field in the first instance of cascading dropdowns.\n\nPlease append the extra fields to the \"Comma separated list of fields (FieldInternalName) in the lookup list.\" field in the cascading dropdown configuration in DFFS backend.");
				return;
			}
			if(spjs.casc.dataObj[argObj.lookupList].data === null){
				setTimeout(function(){
					spjs.casc.init(argObj,false);
				},500);
			}else{
				spjs.casc.init_done(argObj);
			}
			return;
		}		
		if(!argObj.debug){
			spjs.$.each(argObj.thisListFields,function(i,v){
				s = spjs.casc.fields[(v.split(":").length > 1 ? v.split(":")[0] : v)];
				spjs.$(s.field).find('input:text,textarea').hide();
				if(spjs.casc.settings.isSP13){
					spjs.$(s.field).find('input:text,textarea').hide().after("<img class='spjs_casc_spinner' src='"+L_Menu_BaseUrl+"/_layouts/"+(spjs.casc.settings.isSP13 ? "15" : "")+"/images/gears_anv4.gif' style='height:16px;'>");
				}else{
					spjs.$(s.field).find('input:text,textarea').hide();
				}
			});
		}		
	},
	"init_done":function(argObj){
		var dID, s, i, autofill, err = false;
		if(!spjs.casc.cssDone){
			spjs.casc.css();
		}
		if(spjs.casc.isDispForm){
			return;
		}
		if(argObj.multichoiceDelimiter !== undefined){
			spjs.casc.settings.multichoiceDelimiter = argObj.multichoiceDelimiter;
		}
		spjs.casc.getLocalized();
		argObj.numberOfDropdowns = argObj.lookupListFields.length;
		dID = argObj.thisListFields[0].split(":")[0];
		if(typeof dID === "object"){
			dID = dID.fin;
		}
		spjs.casc.multi[dID] = {};
		spjs.$.each(argObj.thisListFields,function(i,v){		
			if(v.split(":").length > 1 && v.split(":")[1] === "multi"){
				spjs.casc.multi[dID][v.split(":")[0]] = true;
				argObj.thisListFields[i] =  v.split(":")[0];				
			}else{
				spjs.casc.multi[dID][v] = false;
			}
		});
		argObj.dropDownDefaultvalue = spjs.casc.translateStringWithJSON(argObj.dropDownDefaultvalue);
		spjs.casc.data[dID] = argObj;
		if(argObj.debug){
			spjs.$("body").prepend("<div style='font-size:14px;color:gray;'>[SPJS Cascading dropdowns v"+spjs.casc.version+"]</div><div id='spjs_casc_debug' style='height:250px;overflow:auto;'></div>");
			alert("[Cascading dropdowns]: Debug is activated.");
			spjs.casc.debugWrite("Function called with these arguments:","font-weight:bold");
			spjs.$.each(argObj,function(x,y){
				spjs.casc.debugWrite(x+":"+y,"margin-left:10px");
			});
		}
		if(spjs.$("#"+dID+"_casc").length > 0){
			return;
		}	
		spjs.$.each(argObj.thisListFields,function(i,v){
			s = spjs.casc.fields[(v.split(":").length > 1 ? v.split(":")[0] : v)];
			if(spjs.casc.multi[dID][v]){
				if(s.type.match("Note") === null){
					alert("[Cascading dropdowns]\n\nWhen using multi select you must change the field \""+s.disp+"\" to type \"Multiple lines of text: Plain text\"");
					err = true;
					return false;
				}
			}else if(s.type.match("Text") === null){
				alert("[Cascading dropdowns]\n\nYou must change the field \""+s.disp+"\" to type \"Single lines of text\"");
				err = true;
				return false;
			}
			if(!spjs.casc.data[dID].debug){
				spjs.$(s.field).find('input:text,textarea').hide();
			}
			var buffer = [];					
			if(spjs.casc.multi[dID][v]){
				buffer.push("<table cellpadding='0' cellspacing='0' style='width:100%;'>");	
				buffer.push("<tr id='"+v+"_casc_unselectedWrap' style='padding:2px;'>");
					buffer.push("<td valign='top'>");
						buffer.push("<div class='spjs_casc_info'>"+spjs.casc.text.unselectedOptions+"</div>");
						buffer.push("<select class='spjs_unselected spjs_casc_multi' id='"+v+"_casc_unselected' multiple></select>");
					buffer.push("</td>");
				buffer.push("</tr>");
				buffer.push("<tr>");
					buffer.push("<td valign='top' id='"+v+"_casc_btnWrap' style='text-align:center;padding-top:10px;'>");
						buffer.push("<input id='"+v+"_casc_btnAdd' type='button' onclick='spjs.casc.add(\""+v+"\",\""+dID+"\","+i+")' value='"+spjs.casc.text.buttonTextAdd+"' disabled>");
						buffer.push("<input id='"+v+"_casc_btnRemove' type='button' onclick='spjs.casc.remove(\""+v+"\",\""+dID+"\","+i+")' value='"+spjs.casc.text.buttonTextRemove+"' disabled>");
					buffer.push("</td>");
				buffer.push("</tr>");
				buffer.push("<tr id='"+v+"_casc_selectedWrap'>");
					buffer.push("<td valign='top'>");
						buffer.push("<div class='spjs_casc_info'>"+spjs.casc.text.selectedOptions+"</div>");
						buffer.push("<select class='spjs_selected spjs_casc_multi' id='"+v+"_casc' multiple></select>");
					buffer.push("</td>");
				buffer.push("</tr>");
				buffer.push("</table>");
				spjs.$(s.field).find('.ms-formbody span:eq(0)').prepend(buffer.join(""));
				spjs.$(s.field).find(".spjs_casc_spinner").remove();				
				spjs.$("#"+v+"_casc_unselected")
					.dblclick(function(){spjs.casc.add(v,dID,i);})
					.focus(function(){spjs.$("#"+v+"_casc_btnRemove").attr("disabled","disabled");spjs.$("#"+v+"_casc_btnAdd").removeAttr("disabled");});
				spjs.$("#"+v+"_casc")
					.dblclick(function(){spjs.casc.remove(v,dID,i);})
					.focus(function(){spjs.$("#"+v+"_casc_btnAdd").attr("disabled","disabled");spjs.$("#"+v+"_casc_btnRemove").removeAttr("disabled");});
			}else{
				buffer.push("<select class='spjs_selected' id='"+v+"_casc'></select>");
				spjs.$(s.field).find('.ms-formbody span:eq(0)').prepend(buffer.join(""));
				spjs.$(s.field).find(".spjs_casc_spinner").remove();
				spjs.$("#"+v+"_casc").change(function(){
					spjs.casc.change(dID,i);
				});
			}
		});
		if(err){
			return;
		}
		i = 0;
		autofill = argObj.autoselectSingleOption === true;
		while(i<argObj.numberOfDropdowns){	
			if(i===0 || spjs.$("#"+argObj.thisListFields[i-1]+"_casc").parents("td.ms-formbody:first").find('input:text,textarea').val() !== ""){
				spjs.casc.fill(dID,true,i,autofill);				
			}else{
				if(argObj.hideEmptyDropdowns){
					spjs.$("#"+argObj.thisListFields[i]+"_casc").parents("td.ms-formbody").parent().addClass("spjs_casc_hidden");
				}
			}
			spjs.casc.load(argObj.thisListFields[i],argObj.clearInvalidSelection);
			i += 1;
		}
		setTimeout(function(){
			if(typeof spjs.dffs === "undefined"){
				spjs.$(".spjs_casc_notvalid").show();
			}
		},1000);
	},
	"add":function(id,dID,index){		
		var s, u;
		s = spjs.$("#"+id+"_casc");
		u = spjs.$("#"+id+"_casc_unselected");
		u.find("option:selected").appendTo(s);
		s.find("option:selected").removeAttr("selected");
		spjs.casc.change(dID,index);	
	},
	"remove":function(id,dID,index){
		var s, t, u;
		s = spjs.$("#"+id+"_casc");
		u = spjs.$("#"+id+"_casc_unselected");		
		s.find("option:selected").each(function(i,opt){
			spjs.$(opt).appendTo(u);
			// Remove orphaned options
			t = spjs.casc.escapeQuotes(spjs.$(opt).attr("title"));
			spjs.$("select.spjs_selected option[title^='"+t+" > ']").each(function(j,cOpt){
				spjs.$(cOpt).remove();
			});
		});
		spjs.casc.change(dID,index);
		u.find("option:selected").removeAttr("selected");
	},
	"hideEmpty":function(){
		// Not in use
	},
	"clear":function(dID,clearDropdownsAfterThis){
		var config, c, u, n;
		config = spjs.casc.data[dID];
		while(clearDropdownsAfterThis<config.numberOfDropdowns){
			c = spjs.$('#'+config.thisListFields[clearDropdownsAfterThis]+'_casc');
			u = spjs.$('#'+config.thisListFields[clearDropdownsAfterThis]+'_casc_unselected');
			n = c.parents("td.ms-formbody:first").find('input:text,textarea');
			n.val("").blur();
			c.html("");
			u.html("");
			if(config.hideEmptyDropdowns){
				c.parents("td.ms-formbody").parent().addClass("spjs_casc_hidden");
			}		
			clearDropdownsAfterThis += 1; 
		}
	},
	"load":function(fin,clear){
		var inp, sel, unsel, t, match;
		if(spjs.casc.fields[fin] === undefined){
			return;
		}
		inp = spjs.$(spjs.casc.fields[fin].field).find('input:text,textarea');
		if(inp.length === 0){
			alert("[Cascading dropdowns]\n\nCannot find the correct input for \""+fin+"\". Ensure you have selected the correct format for the field (single line of text or multi line of plain text).");
			return;
		}
		sel = spjs.$(spjs.casc.fields[fin].field).find('select.spjs_selected');
		t = sel;
		unsel = spjs.$(spjs.casc.fields[fin].field).find('select.spjs_unselected');
		if(unsel.length > 0){
			t = unsel;
		}		
		if(inp.val() !== ""){
			match = false;
			spjs.$.each(inp.val().split(spjs.casc.settings.multichoiceDelimiter),function(i,v){
				t.find("option").each(function(i,o){
					if(spjs.$(o).attr("defaultvalue") === v){
						spjs.$(this).attr("selected","selected");
						match = true;
					}
				}); 
			});
			if(match === false){
				if(clear){					
					spjs.$(spjs.casc.fields[fin].field).addClass("spjs_casc_notvalid").attr("title",spjs.casc.text.invalidData.replace("{0}",inp.val()));
					inp.val("");
				}else{					
					sel.append("<option value='' raw='"+inp.val()+"' disabled='disabled' selected='selected'>"+inp.val()+"</option>");
					spjs.$(spjs.casc.fields[fin].field).addClass("spjs_casc_notvalid").attr("title",spjs.casc.text.invalidData.replace("{0}",inp.val()));
				}				
			}else{				
				if(unsel.length > 0){
					spjs.$("#"+fin+"_casc").append(spjs.$("#"+fin+"_casc_unselected").find("option:selected"));
					spjs.$("#"+fin+"_casc").find("option:selected").removeAttr("selected");
				}
			}
		}
	},
	"change":function(dID,index){
		spjs.$(".spjs_casc_notvalid").removeClass("spjs_casc_notvalid").find("select").attr("title","");
		var config, curr, curr_inp, curr_selected, next, next_inp, multi;
		config = spjs.casc.data[dID];
		curr = spjs.$('#' + config.thisListFields[index] + '_casc');
		multi = spjs.$(curr).hasClass("spjs_casc_multi");
		curr_inp = curr.parents("td.ms-formbody:first").find('input:text,textarea');
		if(config.numberOfDropdowns >= (index+1)){
			curr_selected = [];
			spjs.$.each(curr.find((multi ? "option" : "option:selected")),function(i,o){
				curr_selected.push(spjs.$(o).attr("defaultvalue"));
			});
			if(String(curr_selected) === config.dropDownDefaultvalue){
				curr_inp.val("");
			}else{
				if(multi){
					curr_inp.val(curr_selected.length > 0 ? curr_selected.join(spjs.casc.settings.multichoiceDelimiter) + spjs.casc.settings.multichoiceDelimiter : ""); 
				}else{
					curr_inp.val(String(curr_selected)); 
				}				
			}
			curr_inp.blur();
			if(String(curr_selected) !== config.dropDownDefaultvalue && String(curr_selected) !== ""){
				if(config.numberOfDropdowns>(index+1)){ 
					next = spjs.$('#' + config.thisListFields[(index+1)] + '_casc');
					next_inp = next.parents("td.ms-formbody:first").find('input:text,textarea');				
					next_inp.val("");
					spjs.casc.fill(dID,false,(index+1),true);
					if(!multi){
						spjs.casc.clear(dID,(index+2));
					}else{
						spjs.casc.change(dID,(index+1));
					}
				}
			}else{
				spjs.casc.clear(dID,(index+1));
				// DFFS read only
				next = spjs.$('#' + config.thisListFields[(index+1)] + '_casc');
				next.parents('tr:first').find("td.dffs-readonly-inner div.dffs_tdWrap").html("");
			}
		}
	},
	"fill":function(dID,load,index,autoFill){
		var config, ts, multi, b, c = [], ov, ovPrefix = [], dirtyData = false, pov, lVal, dVal, cVal;
		config = spjs.casc.data[dID];
		if(config.thisListFields[index] === undefined){
			return;
		}
		if(config.debug){			
			spjs.casc.debugWrite("Populating this field","font-weight:bold");
			spjs.casc.debugWrite(config.thisListFields[index],"");
		}
		multi = spjs.$("#"+config.thisListFields[index]+"_casc").hasClass("spjs_casc_multi");
		if(multi){
			ts = spjs.$("#"+config.thisListFields[index]+"_casc_unselected");
			if(!spjs.casc.multi[config.thisListFields[0]][config.thisListFields[index-1]]){
				spjs.$("#"+config.thisListFields[index]+"_casc").html("");
			}
		}else{
			ts = spjs.$("#"+config.thisListFields[index]+"_casc");
		}		
		ts.html("");
		var dup = {}, filter = [], fm;
		spjs.$.each(config.thisListFields,function(fi,fn){
			if(fi < index){
				var fv;
				if(spjs.$("#"+fn+"_casc").hasClass("spjs_casc_multi")){
					fm = [];
					spjs.$("#"+fn+"_casc option").each(function(i,o){
						fm.push(spjs.$(o).attr("raw"));
					});
					filter.push(fm);
				}else{
					fv = spjs.$("#"+fn+"_casc option:selected").attr("raw");
					filter.push(fv);
				}
			}
		});
		b = [];
		spjs.$.each(spjs.casc.dataObj[config.lookupList].data, function(idx,item){
			ovPrefix = [];
			cVal = "";
			ov = item[config.lookupListFields[index].split("/")[0]];
			if(ov === null){
				return;
			}
			if(config.lookupListFields[index].split("/").length > 1){
				// This is an expanded lookup column - get correct object property
				ov = ov[config.lookupListFields[index].split("/")[1]];
			}
			// Filter
			var pass = true;
			spjs.$.each(config.lookupListFields,function(fi,fn){
				if(fi < index){
					cVal = item[config.lookupListFields[fi]];
					if(typeof filter[fi] === "string"){
						if(cVal !== filter[fi]){
							pass = false;
							return false;
						}
					}else{
						pass = false;
						spjs.$.each(filter[fi],function(i,fmv){
							if(cVal === fmv){
								pass = true;
							}
						});
						if(!pass){
							return false;
						}
					}
					ovPrefix.push(spjs.casc.translateStringWithJSON(cVal));
				}
			});
			if(!pass){
				return;
			}
			if(dup[ov] === undefined){
				dup[ov] = true;
			}else{
				return;
			}
			if(ovPrefix.length > 0){
				ovPrefix = ovPrefix.join(" > ")+" > ";
			}
			ovPrefix = spjs.casc.escapeQuotes(ovPrefix);
			ov = String(ov).match(/^\d+;#\w+/) !== null ? ov.split(";#")[1] : ov;
			if(ov.split("  ").length > 1){
				dirtyData = true;
			}
			pov = spjs.casc.parseJSON(ov);
			ov = spjs.casc.escapeQuotes(ov);
			if(typeof pov === "object"){
				lVal = spjs.casc.escapeQuotes(pov[L_Menu_LCID] !== undefined ? pov[L_Menu_LCID] : pov["default"] !== undefined ? pov["default"] : pov);
				dVal = spjs.casc.escapeQuotes(pov["default"]);
				b.push({"title":ovPrefix+lVal,"raw":ov,"defaultval":dVal,"val":item.ID,"text":lVal});
			}else{
				pov = spjs.casc.escapeQuotes(pov);
				b.push({"title":ovPrefix+pov,"raw":ov,"defaultval":ov,"val":item.ID,"text":pov});
			}			
		});
		b.sort(function(a,b){
			if(a.text<b.text){
				return -1;
			}
			if(a.text>b.text){
				return 1;
			}
			return 0;
		});
		spjs.$.each(b,function(i,obj){
			c.push("<option title='"+obj.title+"' raw='"+obj.raw+"' defaultvalue='"+obj.defaultval+"' value='"+obj.val+"'>"+obj.text+"</option>");
		});
		if(config.debug){
			spjs.casc.debugWrite("Number of items returned","font-weight:bold");
			spjs.casc.debugWrite(b.length,"");
			if(b.length === 0){
				spjs.casc.debugWrite("*** Please note that this debug panel cannot determin if the fieldname: \""+config.lookupListFields[index]+"\" in the lookup list is correct.","color:red");
				spjs.casc.debugWrite("*** If you are not getting the options you expected, verify the FieldInternalName: \""+config.lookupListFields[index]+"\" in the lookup list: \""+config.lookupList+"\"","color:red");
			}
		}
		if(b.length === 0){
			if(config.hideEmptyDropdowns){
				ts.parents("td.ms-formbody").parent().addClass("spjs_casc_hidden");
			}
		}else{
			if(!spjs.casc.multi[dID][config.thisListFields[index]]){
				c.unshift("<option value='0'>"+config.dropDownDefaultvalue.replace(/</,'&lt;').replace(/>/,'&gt;')+"</option>");
			}
			ts.html(c.join(""));
			if(dirtyData && ts.parent().find("img.spjs_casc_dirty").length === 0){
				ts.after("<img class='spjs_casc_dirty' style='vertical-align:middle;' title='The datasource contains multiple white spaces. Internet Explorer will strip these away, resulting in a failed query. Clean your datasource to ensure a consistent behavior.' src='"+L_Menu_BaseUrl+"/_layouts/images/exclaim.gif'>");
			}
			ts.parents("td.ms-formbody").parent().removeClass("spjs_casc_hidden");
		}
		if(config.autoselectSingleOption === undefined){
			config.autoselectSingleOption = true;
		}
		if(b.length === 1 && config.autoselectSingleOption && autoFill){
			if(multi){
				ts.find("option:last").prop("selected","selected").trigger("dblclick");
			}else{
				pov = spjs.casc.parseJSON(ts.find("option:last").attr("raw"));
				if(typeof pov === "object"){
					lVal = pov[L_Menu_LCID] !== undefined ? pov[L_Menu_LCID] : pov["default"] !== undefined ? pov["default"] : pov;
					dVal = pov["default"];
					ts.siblings("input:text").val(dVal).trigger("blur");
				}else{
					ts.siblings("input:text").val(pov).trigger("blur");
				}					
			}
			ts.find("option:last").prop("selected","selected");
			if(!load){
				setTimeout(function(){
					spjs.casc.fill(dID,load,(index+1),autoFill);
				},100);
			}
		}
		if(multi){
			spjs.$("#"+config.thisListFields[index]+"_casc option").each(function(i,o){
				if(spjs.$("#"+config.thisListFields[index]+"_casc_unselected").find("option[value='"+spjs.$(o).val()+"']").length > 0){
					spjs.$("#"+config.thisListFields[index]+"_casc_unselected").find("option[value='"+spjs.$(o).val()+"']").remove();						
				}
			});
		}
		// DFFS read only
		if(ts.parents('tr:first').find("td.dffs-readonly-inner").length > 0){
			ts.parents('tr:first').find("td.dffs-readonly-inner div.dffs_tdWrap").html(ts.siblings("input:text").val());
		}		
	},
	"escapeQuotes":function(s){
		return String(s).split("'").join("&#39;").split("\"").join("&#34;");
	},
	"parseJSON":function(a){
		var b = a;
		if(b.charAt(0) === "{"){
			try{
				b = spjs.$.parseJSON(a);
				if(b["default"] === undefined){
					b["default"] = b[L_Menu_LCID];
					b[L_Menu_LCID] = b[L_Menu_LCID] + " [The JSON object in the dataset are missing the \"default\" value]";
				}		
			}catch(ignore){
				// Nothing
			}
		}
		return b;
	},
	"getAllItems":function(args,argObj){
		args.viewFields.push("ID");
		var res = spjs.utility.queryItemsThrottled({"listName":args.listName,"listBaseUrl":args.listBaseUrl,"query":"<Where><IsNotNull><FieldRef Name='ID' /></IsNotNull></Where>","viewFields":args.viewFields});
		if(res.errorText !== undefined){
			alert("[Cascading dropdowns :: Error in query]\n\n"+res.errorText);
		}else{
			spjs.casc.dataObj[args.listName].data = res.items;
			spjs.casc.init_done(argObj);
		}
	},
	"getAllItemsREST":function(args,argObj,endpoint){
		var isGuid, s, select = [], expand = [];
		if(endpoint === ""){
			argObj.lookupListFields.push("Id");
			isGuid = spjs.casc.isGuid(args.listName);
			$.each(argObj.lookupListFields,function(i,f){
				select.push(f);
				if(f.split("/").length > 1){
					expand.push(f.split("/")[0]);
				}
			});
			endpoint = args.listBaseUrl+ "/_api/web/lists/"+(isGuid ? "getById" : "getbytitle")+"('" + args.listName + "')/items?$top=5000&$select="+select.join(",")+(expand.length > 0 ? "&$expand="+expand.join(",") : "");
		}
		$.ajax({
			"url": endpoint,
			"method": "GET",
			"headers": { "Accept": "application/json; odata=verbose" },
			"success": function (data) {
				if(spjs.casc.dataObj[args.listName].data === null){
					spjs.casc.dataObj[args.listName].data = [];
				}
				spjs.$.merge(spjs.casc.dataObj[args.listName].data,data.d.results);
				if(data.d.__next !== undefined){
					spjs.casc.getAllItemsREST(args,argObj,data.d.__next);
				}else{
					spjs.casc.init_done(argObj);
				}
			},
			"error": function (data) {
				var et = "";
				spjs.$.each(argObj.thisListFields,function(i,v){
					s = spjs.casc.fields[(v.split(":").length > 1 ? v.split(":")[0] : v)];
					try{
						et = data.responseJSON.error.message.value;
					}catch(ignore){
						et = "An error occurred. Please review the setup.";
					}
					spjs.$(s.field).find(".spjs_casc_spinner").replaceWith("<span style='color:red;'>"+et+"</span>");
				});
			}
		});
	},
	"isGuid":function(a){
		return a.match(/[a-f0-9]{8}(?:-[a-f0-9]{4}){3}-[a-f0-9]{12}/i) !== null;
	}
};

// http://www.steveworkman.com/html5-2/javascript/2011/improving-javascript-xml-node-finding-performance-by-2000/
spjs.$.fn.filterNode = function(name) {
	return this.find('*').filter(function() {
		return this.nodeName === name;
	});
};